/**
  ******************************************************************************
  * @file stm8s_it.c\RIDE_Project
  * @brief This file contains all the interrupt routines.
  * @author STMicroelectronics
  * @version V0.03
  * @date 29-NOV-2007
  ******************************************************************************
  *
  * THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2007 STMicroelectronics</center></h2>
  * @image html logo.bmp
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#pragma SRC
//#include "stm8s_can.h"
#include "stm8s_flash.h"
#include "config_commands.h"
#include "firmware_config.h"
#include "CAN_Message.h"
#include "intrist7.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
/* Public functions ----------------------------------------------------------*/
#define CAN_GetDataFW (*((void(*)(void))0xC600))
#define CAN_GetDataBL (*((void(*)(void))0xB000))

/* Public Interruption routines ----------------------------------------------------------*/
void TLI_IRQHandler (void) interrupt 0
{
}
void AWU_IRQHandler (void) interrupt 1
{
}
void CLK_IRQHandler (void) interrupt 2
{
}
void EXTI_PORTA_IRQHandler (void) interrupt 3
{
}
void EXTI_PORTB_IRQHandler (void) interrupt 4
{
}
void EXTI_PORTC_IRQHandler (void) interrupt 5
{
}
void EXTI_PORTD_IRQHandler (void) interrupt 6
{
}
void EXTI_PORTE_IRQHandler (void) interrupt 7
{
}

void CAN_RX_IRQHandler (void) interrupt 8
{   
	// An interrupt generated by activity on CAN_RX pin.
    // Need to read message or interrupt will continuously 
	// be generated.
if (FLASH_ReadByte(0x9000) == 0x01)
    CAN_GetDataBL();
else if (FLASH_ReadByte(0x9000) == 0x02)
    CAN_GetDataFW();
else
    CAN_GetDataBL();

}

void CAN_TX_IRQHandler (void) interrupt 9
{
	
}
void SPI_IRQHandler (void) interrupt 10
{
}
void TIM1_UPD_OVF_TRG_BRK_IRQHandler (void) interrupt 11
{
}
void TIM1_CAP_COM_IRQHandler (void) interrupt 12
{
}
void TIM2_UPD_OVF_BRK_IRQHandler (void) interrupt 13
{
}
void TIM2_CAP_COM_IRQHandler (void) interrupt 14
{
}
void TIM3_UPD_OVF_BRK_IRQHandler (void) interrupt 15
{
}
void TIM3_CAP_COM_IRQHandler (void) interrupt 16
{
}
void UART2_TX_IRQHandler (void) interrupt 17
{
}
void UART2_RX_IRQHandler (void) interrupt 18
{
}
void I2C_IRQHandler (void) interrupt 19
{
}
void UART1_TX_IRQHandler (void) interrupt 20
{
}
void UART1_RX_IRQHandler (void) interrupt 21
{
}
void ADC_IRQHandler (void) interrupt 22
{
}
void TIM4_UPD_OVF_IRQHandler (void) interrupt 23
{
}
void EEPROM_EEC_IRQHandler (void) interrupt 24
{
}

/**
  * @}
  */

/******************* (C) COPYRIGHT 2008 STMicroelectronics *****END OF FILE****/
