/*Include files*/
#include "stm8s_conf.h"
#include "read_ID.h"
#include "stm8s_gpio.h"
#include "noptiming.h"
#include <stdio.h>

void OWWriteBit(u8 writebit){


    if (writebit){
        // Write '1' bit
        GPIOE->ODR &= (u8)(~GPIO_PIN_4);
         
        GPIOE->ODR |= GPIO_PIN_4;
        NOP100; 
        //NOP40; 
    }

    else{  
        // Write '0' bit
        GPIOE->ODR &= (u8)(~GPIO_PIN_4);
        NOP80; 
        GPIOE->ODR |= GPIO_PIN_4;
        //NOP140;
        NOP100;
    }
}


void OWReadID(){
	// called when CAN message received requesting ID
	
	extern u8 G_BOARDID[8];		// Global variable that will house board ID
    u8 result = 0x00;
    u8 result2;
    unsigned int loop;
    u8 byte = 0x33;
    unsigned int i;
    
	// |=   is bitwise OR
	// ~ 	flips every bit => ~(1100) = (0011)
    /*Initialize output mode*/
    GPIOE->ODR |= GPIO_PIN_4;			// set ODR bit 1
    GPIOE->DDR |= GPIO_PIN_4;			// set DDR bit 1
    GPIOE->CR1 &= (u8)(~(GPIO_PIN_4));	// set CR1 bit 0
    GPIOE->CR2 |= GPIO_PIN_4;			// set CR2 bit 1
    
    // Write low and hold pin low for > 480mus
    GPIOE->ODR &= (u8)(~GPIO_PIN_4);	// set ODR bit 0
    NOP500;
    
	// Let pin go... resistor will now pull pin high and then 
	// after a short delay, DS2401 will send presence pulse 
	// i.e. the DS2401 will pull the pin low.
    /*Initialize input mode*/
    GPIOE->DDR &= (u8)(~(GPIO_PIN_4));	// set DDR bit 0
    GPIOE->CR1 &= (u8)(~(GPIO_PIN_4));	// set CR1 bit 0
    GPIOE->CR2 &= (u8)(~(GPIO_PIN_4));	// set CR2 bit 0
    
    /*Read pin*/
    //result1 = ((BitStatus)(GPIOE->IDR & (u8)GPIO_PIN_4));
    
    NOP500;
    
    /*Initialize output mode*/
    //GPIOE->ODR &= (u8)(~(GPIO_PIN_4));  // changing this.. this pulls pin low
    GPIOE->ODR |= (u8)((GPIO_PIN_4));  // this leaves pin high
    GPIOE->DDR |= GPIO_PIN_4;
    GPIOE->CR1 &= (u8)(~(GPIO_PIN_4));
    GPIOE->CR2 |= GPIO_PIN_4;
    
    // Loop to write each bit; Least significant bit first
	// For 0x33 this means writing 11001100.
    for (loop = 0; loop < 8; loop++){     
		// NB byte = 0x33
        OWWriteBit( byte & 0x01);
    
        //Shift data register to next bit 
        byte >>= 1;
    }
    
    for( i = 0; i < 6; i++) {
		result = 0x00;
        /*Read byte*/
		NOP100;  // this delay just makes bytes easier to distinguish on scope...
        for(loop = 0; loop < 8; loop++){
			// read bit
			
			//shift result to get ready for next bit
			result >>= 1;
            
			/*Initialize output mode*/
			GPIOE->ODR |= (u8)((GPIO_PIN_4));  // this leaves pin high	
			GPIOE->DDR |= GPIO_PIN_4;
			GPIOE->CR1 &= (u8)(~(GPIO_PIN_4));
			GPIOE->CR2 |= GPIO_PIN_4;

			//Write low
			GPIOE->ODR &= (u8)(~GPIO_PIN_4);

			/*Initialize input mode*/
			GPIOE->DDR &= (u8)(~(GPIO_PIN_4));
			GPIOE->CR1 &= (u8)(~(GPIO_PIN_4));
			GPIOE->CR2 &= (u8)(~(GPIO_PIN_4));
        
			// wait for DS2401 to pull pin low (or not) before reading pin...
			NOP12;
			//NOP5;
            
			//Read pin
			result2 = ((BitStatus)(GPIOE->IDR & (u8)GPIO_PIN_4));
			
			NOP50;
    
			if(result2) result |= 0x80;
        }
        
      //id[i] = result;
      G_BOARDID[i] = result;
    }
    
    return;
}