
#include <intrist7.h>   /* Defines the _nop_() intrinsic function */
#include "stm8s_conf.h"
#include "stm8s_lib.h"
#include "firmware_config.h"
#include "CAN_Message.h"

/*************************************GPIO functions**************************************************/
u8 byte1;
u8 byte2;

void ConfigLEDs(void)
{
    GPIO_Init(LEDS_PORT, (LED_RED_PIN | LED_GREEN_PIN), GPIO_MODE_OUT_OD_LOW_SLOW);
}



void Config_IO_CAN(void)
{
    // CAN_TX
    GPIO_Init(GPIOG, GPIO_PIN_0, GPIO_MODE_OUT_PP_HIGH_FAST);
    // CAN_RX
    //GPIO_Init(GPIOG, GPIO_PIN_1, GPIO_MODE_IN_PU_NO_IT);
    GPIO_Init(GPIOG, GPIO_PIN_1, GPIO_MODE_IN_PU_IT);
    // Configure the CAN transceiver in active mode
    GPIO_Init(GPIOC, GPIO_PIN_3, GPIO_MODE_OUT_PP_LOW_FAST);
	

	
}

void Config_ADC_CURR(void)
{
	
    ADC2_DeInit();
    
    ADC2_Init(ADC2_CONVERSIONMODE_CONTINUOUS,
              MON_CURR_CHANNEL,
              ADC2_PRESSEL_FCPU_D2,
              ADC2_EXTTRIG_TIM,
              DISABLE,
              ADC2_ALIGN_RIGHT,
              MON_CURR_SCHMITTTRIG_CHANNEL,
              DISABLE);

    ADC2_ITConfig(DISABLE);  
  
    ADC2_StartConversion();  
}

void Config_ADC_TEMP(void)
{
    
    ADC2_DeInit();
    
    ADC2_Init(ADC2_CONVERSIONMODE_CONTINUOUS,
              MON_TEMP_CHANNEL,
              ADC2_PRESSEL_FCPU_D2,
              ADC2_EXTTRIG_TIM,
              DISABLE,
              ADC2_ALIGN_RIGHT,
              MON_TEMP_SCHMITTTRIG_CHANNEL,
              DISABLE);

    ADC2_ITConfig(DISABLE);  
  
    ADC2_StartConversion();  
}
void Config_ADC_VDAC(void)
{
    
    ADC2_DeInit();
    
    ADC2_Init(ADC2_CONVERSIONMODE_CONTINUOUS,
              MON_VDAC_CHANNEL,
              ADC2_PRESSEL_FCPU_D2,
              ADC2_EXTTRIG_TIM,
              DISABLE,
              ADC2_ALIGN_RIGHT,
              MON_VDAC_SCHMITTTRIG_CHANNEL,
              DISABLE);

    ADC2_ITConfig(DISABLE);  
  
    ADC2_StartConversion();  
}
void Config_ADC_VCATH(void)
{
    
    ADC2_DeInit();
    
    ADC2_Init(ADC2_CONVERSIONMODE_CONTINUOUS,
              MON_VCATH_CHANNEL,
              ADC2_PRESSEL_FCPU_D2,
              ADC2_EXTTRIG_TIM,
              DISABLE,
              ADC2_ALIGN_RIGHT,
              MON_VCATH_SCHMITTTRIG_CHANNEL,
              DISABLE);

    ADC2_ITConfig(DISABLE);  
  
    ADC2_StartConversion();  
}

void Config_ADC_VDY01(void)
{
    
    ADC2_DeInit();
    
    ADC2_Init(ADC2_CONVERSIONMODE_CONTINUOUS,
              MON_VDY01_CHANNEL,
              ADC2_PRESSEL_FCPU_D2,
              ADC2_EXTTRIG_TIM,
              DISABLE,
              ADC2_ALIGN_RIGHT,
              MON_VDY01_SCHMITTTRIG_CHANNEL,
              DISABLE);

    ADC2_ITConfig(DISABLE);  
  
    ADC2_StartConversion();  
}
void Config_ADC_MVT(void)
{
    
    ADC2_DeInit();
    
    ADC2_Init(ADC2_CONVERSIONMODE_CONTINUOUS,
              MON_MVT_CHANNEL,
              ADC2_PRESSEL_FCPU_D2,
              ADC2_EXTTRIG_TIM,
              DISABLE,
              ADC2_ALIGN_RIGHT,
              MON_MVT_SCHMITTTRIG_CHANNEL,
              DISABLE);

    ADC2_ITConfig(DISABLE);  
  
    ADC2_StartConversion();  
}
void Config_ADC_MVB(void)
{
    
    ADC2_DeInit();
    
    ADC2_Init(ADC2_CONVERSIONMODE_CONTINUOUS,
              MON_MVB_CHANNEL,
              ADC2_PRESSEL_FCPU_D2,
              ADC2_EXTTRIG_TIM,
              DISABLE,
              ADC2_ALIGN_RIGHT,
              MON_MVB_SCHMITTTRIG_CHANNEL,
              DISABLE);

    ADC2_ITConfig(DISABLE);  
  
    ADC2_StartConversion();  
}

//set HV value
void setHV( u8 voltage1, u8 voltage2){
	
	// voltage1 = 1st byte (most significant bits) of voltage to send
	// voltage2 = 2nd byte (most significant bits) of voltage to send
	// minVoltage ==> voltage1 = 0x00 and voltage2 = 0x00
	// maxVoltage ==> voltage1 = 0xFF and voltage2 = 0xF0	(DAC is 12 bit)
	
    GPIO_Init(DAC_PORT, DAC_CS_PIN, GPIO_MODE_OUT_PP_HIGH_SLOW);
    
    SPI_DeInit();
    SPI_Init(SPI_FIRSTBIT_MSB, SPI_BAUDRATEPRESCALER_2, SPI_MODE_MASTER, SPI_CLOCKPOLARITY_LOW, SPI_CLOCKPHASE_1EDGE, SPI_DATADIRECTION_1LINE_TX, SPI_NSS_SOFT, 0x07);
    SPI_Cmd(ENABLE);
    
    GPIO_WriteLow(DAC_PORT,DAC_CS_PIN);
    SPI_SendData(0x30);	// equivalent to 0011 0000	i.e. 4 bit command to write to DAC + 4 ignored bits
    SPI_SendData(voltage1);		// first 8 bits of voltage	(most significant bits) say 0xFF		
    SPI_SendData(voltage2);		// next 4 bits say 0xF0 (plus 4 bits that will be ignored)
    GPIO_WriteHigh(DAC_PORT,DAC_CS_PIN);
}
    

/*****************************************************************************

/*****************************************************************************
 * Delay function, waiting for a defined period. The function is approximately
 * calibrated so that it will wait for a given number of 1ms periods. The
 * approximation assumes that the processor has a 12MHz clock.
 * @param[in] cnt is the number of milliseconds to wait.
 * @retval void None
 */
void delay(unsigned int cnt)
{
    unsigned short loop;

    /* Decrement counter until it is zero */
    while (cnt--)
        for(loop = 921; loop; loop--)   /* Wait for approximatively 1 ms */ 
            _nop_(); 
}

/*****************************************************************************
 * Set the REva LEDs D0-D7 to the "newData" value.
 */
void SetLEDs(u8 newData)
{
	GPIO_Write(LEDS_PORT, 0x00);
    GPIO_Write(LEDS_PORT, ~newData);
}

void FlashLEDs( unsigned int nTimes ){
	// flash the LEDs
	unsigned short i;
	
	for( i=0; i<nTimes; i++ ){
		SetLEDs(LED_RED_PIN);
		delay(10);
		SetLEDs(LED_GREEN_PIN);
		delay(10);
		SetLEDs(0x00);
		delay(10);
	}
}


/*****************************************************************************
 * Configure the clock as High Speed External.
 * Note that 12 MHz should be readily available to the STM8. This requires a
 * specific wire if you are using the STM8 daughterboard on REva.
 *
 * If the switch does not succeed, the function calls error().
 */
void Config_Clock(void)
{
    ErrorStatus status = FALSE;
    u8 cnt = 0;
    u8 dummy = 0;

    status = CLK_ClockSwitchConfig(CLK_SWITCHMODE_AUTO, CLK_SOURCE_HSE, DISABLE, DISABLE);

    // Wait for HSE stabilization
    while(CLK_GetSYSCLKSource() != CLK_SOURCE_HSE)
    {
        // Wait only 255 times
        if(--cnt == 0)
             dummy++;
    }

    // Configure the CAN divider
    CLK_CANConfig(CLK_CANDIVIDER_1);
}


//Configures CPU clock to 1 MHz and Master clock to 2 MHz

void Config_InternalClock(void)
{
    
    ErrorStatus status = FALSE;

	// change to slow low
    GPIO_Init(GPIOE, GPIO_PIN_0, GPIO_MODE_OUT_PP_HIGH_SLOW);
    
    status = CLK_ClockSwitchConfig(CLK_SWITCHMODE_AUTO, CLK_SOURCE_HSI, DISABLE, DISABLE);
    
    CLK_HSIPrescalerConfig(CLK_CKDIVR_HSIDIV);
    
    CLK->PCKENR2 |= CLK_PCKENR2_CAN;
    
    CLK_CCOCmd(ENABLE);
	
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_TIMER1, DISABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_TIMER2, DISABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_TIMER3, DISABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_TIMER4, DISABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_I2C, DISABLE);   
	//CLK_PeripheralClockConfig(CLK_PERIPHERAL_SPI, DISABLE);   
	//CLK_PeripheralClockConfig(CLK_PERIPHERAL_USART, DISABLE); 
	//CLK_PeripheralClockConfig(CLK_PERIPHERAL_LINUART, DISABLE);    
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_UART1, DISABLE); 
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_UART2, DISABLE); 
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_AWU, DISABLE);
	//CLK_PeripheralClockConfig(CLK_PERIPHERAL_ADC, DISABLE); 
	//CLK_PeripheralClockConfig(CLK_PERIPHERAL_CAN, DISABLE); 
		
}