#include <intrist7.h>   /* Defines the _nop_() intrinsic function */
#include <stdio.h>     /* contains sprintf */
//#include <stdint.h>    /* for larger integer types */
#include "stm8s_conf.h"
#include "stm8s_lib.h"
#include "stm8s_can.h"
#include "stm8s_flash.h"
#include "firmware_config.h"	
#include "CAN_Message.h"
#include "read_ID.h"
#include "config_commands.h"
#include "main.h"

/*****************************************************************************
 * Can handling functions.
 */
 
extern u16 vcath_vals[8];
extern u16 mvt_vals[8];
extern u16 mvb_vals[8];
extern u16 vdy01_vals[8];
extern u16 vdac_vals[8];
extern u16 curr_vals[8];
extern u16 temp_vals[8];

 

extern u8 HV_set1;           
extern u8 HV_set2;


volatile CanRxMsg _RxMessage;
volatile CanTxMsg _TxMessage;

volatile CAN_InitTypeDef        _CAN_InitStructure;
volatile CAN_FilterInitTypeDef  _CAN_FilterInitStructure;

void CAN_InitTransmit(void)
{
    extern u8 G_BOARDID[8];	
	
	// G_BOARDID[1] contains EXID[7:0]
	// G_BOARDID[2] contains EXID[15:8]
	// G_BOARDID[3] contains EXID[23:16]
	u8 idBits_6_0_X;			
	u8 idBits_14_7;
	u8 idBits_20_18_X_17_15;
	u8 idBits_X_23_21;          
	u8 x; 
	u8 y; 
	u8 z; 
	u8 a; 
	u8 b; 
	u8 c; 
	u8 d; 
	u8 e; 
	u8 f;  
	x = G_BOARDID[3];
	y = G_BOARDID[2];
	z = G_BOARDID[1];
	a = (x >> 5) & 0x07;
	b = (x >> 2) & 0x07;
	c = ( (x << 1) & 0x06 ) | ( (y >> 7) & 0x01 );
	d = ( (y << 1) & 0xFE ) | ( (z >> 7) & 0x01 );
	e = (z << 1) & 0xFE;
	f = ( ( (b << 5) & 0xE0 ) | c ) | 0x08;
	
	idBits_6_0_X = e;
	idBits_14_7 = d;
	idBits_20_18_X_17_15 = f;
	idBits_X_23_21 = a;

    // CAN register init 
    CAN_DeInit();
    CAN_StructInit(&_CAN_InitStructure);
	
    // Initialize for a 50kHz baud rate 
    // CAN cell init 
	_CAN_InitStructure.ABOM=ENABLE;   //d.w.b. Recover from Bus-Off state if too many errors.
    _CAN_InitStructure.TXFP=DISABLE;
    _CAN_InitStructure.SJW=CAN_SJW_4tq;
    _CAN_InitStructure.BS1=CAN_BS1_16tq;
    _CAN_InitStructure.BS2=CAN_BS2_3tq;
    _CAN_InitStructure.Prescaler=2;	  // this prescaler works with 1MHz clock
	CAN_Init(&_CAN_InitStructure);
	

    // CAN filter init 
    //---------------------------------------------------------------
	// Set up first filter to filter on chip ID:
	// NB. Must have RTR bit = 0 and IDE = 1
    //---------------------------------------------------------------
	
    _CAN_FilterInitStructure.CAN_FilterNumber=0;
    _CAN_FilterInitStructure.CAN_FilterMode=((u8)0x03);  // id list mode 
    _CAN_FilterInitStructure.CAN_FilterScale=CAN_FilterScale_32bit; // make sure CAN_FilterScale_32bit = 0x03
    	
	// 32-bit filter 1 (ext ID = chip id):
    _CAN_FilterInitStructure.CAN_FilterIdLow1=idBits_X_23_21;
    _CAN_FilterInitStructure.CAN_FilterIdLow2=idBits_20_18_X_17_15;
    _CAN_FilterInitStructure.CAN_FilterIdHigh1=idBits_14_7;
    _CAN_FilterInitStructure.CAN_FilterIdHigh2=idBits_6_0_X;
	
    _CAN_FilterInitStructure.CAN_FilterMaskIdLow1=idBits_X_23_21;
    _CAN_FilterInitStructure.CAN_FilterMaskIdLow2=idBits_20_18_X_17_15;
    _CAN_FilterInitStructure.CAN_FilterMaskIdHigh1=idBits_14_7;
    _CAN_FilterInitStructure.CAN_FilterMaskIdHigh2=idBits_6_0_X;
	
    _CAN_FilterInitStructure.CAN_FilterActivation=ENABLE;
    CAN_FilterInit(&_CAN_FilterInitStructure);
	
    //---------------------------------------------------------------
	
    //---------------------------------------------------------------
	// Set up a second filter to also accept messages with ID 0x0: 
	// NB. Must have RTR bit = 0 and IDE = 1
    //---------------------------------------------------------------
	
    _CAN_FilterInitStructure.CAN_FilterNumber=1;
    _CAN_FilterInitStructure.CAN_FilterMode=((u8)0x03);  //id list mode 
    _CAN_FilterInitStructure.CAN_FilterScale=CAN_FilterScale_32bit; // make sure CAN_FilterScale_32bit = 0x03

	// 32-bit filter 1 (ext ID = 0x0):
    _CAN_FilterInitStructure.CAN_FilterIdLow1=0x00;
    _CAN_FilterInitStructure.CAN_FilterIdLow2=0x08;
    _CAN_FilterInitStructure.CAN_FilterIdHigh1=0x00;
    _CAN_FilterInitStructure.CAN_FilterIdHigh2=0x00;

    _CAN_FilterInitStructure.CAN_FilterMaskIdLow1=0x00;
    _CAN_FilterInitStructure.CAN_FilterMaskIdLow2=0x08;
    _CAN_FilterInitStructure.CAN_FilterMaskIdHigh1=0x00;
    _CAN_FilterInitStructure.CAN_FilterMaskIdHigh2=0x00;
	
    _CAN_FilterInitStructure.CAN_FilterActivation=ENABLE;
    CAN_FilterInit(&_CAN_FilterInitStructure);
	
    //---------------------------------------------------------------

    // Request leave initialisation 
    CAN_MCR &= (u8)(~CAN_MCR_INRQ);
    // Wait the acknowledge 
	
    while (CAN_MSR & CAN_MCR_INRQ);
    // ...and check acknowledged 
    //if ((CAN_MSR & CAN_MSR_INAK) == CAN_MSR_INAK)
    //{
    //    InitStatus = CANINITFAILED;
    //}
    
    while(CAN_MessagePending()>=1); //wait til mbx is empty
	
}

void CAN_TransmitPowerDown(void){
	// Pull CAN_STBY pin high - won't be able to read CAN messages
	GPIO_WriteHigh( GPIOC, CAN_STBY_PIN );
	// enable external interrupts on PC1 so that
	// base can be woken back up by activity on CAN_RX line
	GPIOC->CR2 |= GPIO_PIN_1;
}
void CAN_TransmitPowerUp(void){
	// Pull CAN_STBY pin low - MCU will now be able to read/write
	// CAN messages
	GPIO_WriteLow( GPIOC, CAN_STBY_PIN );
	// disable external interrupts on PC1 
	GPIOC->CR2 &= ~GPIO_PIN_1;
}

at 0xC600 void CAN_GetDataFW(void)
{
   	u8 TxData[8];

    u32 i;
    u32 ii;
    u32 variance=0;
    u32 v_sum=0;
    u32 v_sum_sq=0;
    u16 my_max;
    u16 my_min;
    u8  my_min_i;
    u8  my_max_i;
    u8  redo_index;
    u16 HV_received = ((HV_set1 << 4) | (HV_set2 & 0x00F0)>>4); 


    //CanRxMsg RxMessage;
    u8 transmitMailbox;
    u16 conversionValue;
	u8 hvStatus;
    u16 my_val;

	// initialise data array for can message	
    for(i=0; i<8; i++){
        TxData[i] = 0x0;
    }
    TxData[3] = 0xFF; //Set this one high by default

    // receive 
    _RxMessage.StdId=(u16)(0x0000);
    _RxMessage.IDE=CAN_ID_EXT;
    _RxMessage.DLC=0;
    _RxMessage.Data[0]=0x00;
    _RxMessage.Data[1]=0x00;
    _RxMessage.Data[2]=0x00;
    _RxMessage.Data[3]=0x00;
    _RxMessage.Data[4]=0x00;
    _RxMessage.Data[5]=0x00;
    _RxMessage.Data[6]=0x00;
    _RxMessage.Data[7]=0x00;

    while( ( CAN_MessagePending() ) < 1 );

    CAN_Receive(&_RxMessage);
	
	//FlashLEDs( 1 ); // debugging... signal that you've received a message

	
    // Enter powerdown
    if ((u8)(_RxMessage.Data[0]) == COMMAND_PD){
		CAN_TransmitPowerDown();
    } 
	// Power back up 
    else if ((u8)(_RxMessage.Data[0]) == COMMAND_PU){
		CAN_TransmitPowerUp();
    } 
    //Read ADC
    else if ((u8)(_RxMessage.Data[0]) == COMMAND_ADC){
            
        u32 sum = 0;
        u16 readin[32];
        u8 READ_ADC = 0xFF;
        if ((u8)(_RxMessage.Data[1]) == READ_VCATH) {
            for(i = 0; i<32; ++i) {
            Config_ADC_VCATH();
            readin[i] = ADC2_GetConversionValue();
            delay(1);
            }
            READ_ADC = READ_VCATH;}
        if ((u8)(_RxMessage.Data[1]) == READ_CURR) {
            for(i = 0; i<32; ++i) {
            Config_ADC_CURR();
            readin[i] = ADC2_GetConversionValue();
            delay(1);
            }
            READ_ADC = READ_CURR;}
        if ((u8)(_RxMessage.Data[1]) == READ_MVB) {
            Config_ADC_MVB();
            sum = ADC2_GetConversionValue();
            READ_ADC=READ_MVB;
            }
        if ((u8)(_RxMessage.Data[1]) == READ_MVT) {
            Config_ADC_MVT();
            sum = ADC2_GetConversionValue();
            READ_ADC=READ_MVT;
            }
        if ((u8)(_RxMessage.Data[1]) == READ_VDY01) {
            Config_ADC_VDY01();
            sum = ADC2_GetConversionValue();
            READ_ADC=READ_VDY01;
            }
        if ((u8)(_RxMessage.Data[1]) == READ_VDAC) {
            Config_ADC_VDAC();
            sum = ADC2_GetConversionValue();
            READ_ADC=READ_VDAC;
            }
        if ((u8)(_RxMessage.Data[1]) == READ_TEMP) {
            Config_ADC_TEMP();
            sum = ADC2_GetConversionValue();
            READ_ADC=READ_TEMP;
            }
        ADC2_DeInit();
        
        
        //Sample current every 1 ms 32 times
        if((u8)(_RxMessage.Data[1]) == READ_CURR) {
            for (i = 0; i < 32; ++i) {
                sum+=readin[i];
            }
            sum = sum >> 5;
        }
    
        //Sample voltage every 1 ms 32 times
        //If variance of 32 samples !=0
        //then resample point with largest deviation from mean
        //until variance==0 (to 10-bit precision) 

        if((u8)(_RxMessage.Data[1]) == READ_VCATH) {  
        
            u16 n_tries=0;
            v_sum=0;
            v_sum_sq=0;

            for(i = 0; i<32; i++) {
                my_val = readin[i];
                v_sum += (u32)my_val;
                v_sum_sq += (u32)my_val*(u32)my_val;
            }
            variance = ((u32)v_sum_sq - (u32)v_sum*(u32)v_sum/(u32)32)/(u32)32;

            while(variance != (u32)0 && n_tries!=25) {
                n_tries++;
                v_sum=0;
                v_sum_sq=0;
                my_min=0xFFFF;
                my_max=0x0000;

                for(i = 0; i<32; i++) {
                    my_val = readin[i];
                    v_sum += (u32)my_val;
                    v_sum_sq += (u32)my_val*my_val;
                }
            
                variance = ((u32)v_sum_sq - (u32)v_sum*(u32)v_sum/(u32)32)/(u32)32;
            
                for(ii = 0; ii<32; ii++) {
                    if(readin[ii] < my_min) {my_min = readin[ii]; my_min_i = ii;}
                    if(readin[ii] > my_max) {my_max = readin[ii]; my_max_i = ii;}
                }
            
                redo_index = ((my_max-v_sum/32)>(v_sum/32 - my_min) ? my_max_i : my_min_i);
                Config_ADC_VCATH();
                readin[redo_index] = ADC2_GetConversionValue();
                ADC2_DeInit();
            
            }
        
        sum = v_sum>>5;
        }

        
        //Sends back received value for HV
        if((u8)(_RxMessage.Data[1]) == READ_VSET) {
            TxData[0] = COMMAND_ADC;
            TxData[1] = (u8)(HV_received >> 4) & 0xFF ;
            TxData[2] = (u8)((HV_received << 4) & 0xF0);
            TxData[3] = (u8)READ_VSET;
            transmitMailbox = CAN_SendData(&TxData[0]);
        }
    
    //Else send any other type of message
        else{
            //Send CAN message
            TxData[0] = COMMAND_ADC;
            TxData[1] = (u8)( ((u8)(sum>>(u8)8)) & 0x003);
            TxData[2] = (u8)(sum & 0x0FF);
            TxData[3] = (u8)READ_ADC;
        
            //Debugging... send out variance. Should always be 0.
            
            if(READ_ADC==READ_VCATH) {
            TxData[4] = (u8)variance>>8 & 0x0FF;
            TxData[5] = (u8)variance & 0x0FF;
            TxData[6] = (u8)v_sum & 0b00011111;
            
            }
            
            transmitMailbox = CAN_SendData(&TxData[0]);
        }
    }


    //Set DAC
    else if ((u8)(_RxMessage.Data[0]) == COMMAND_DAC){
		
        u8 DA1;
        u8 DA2;
        
        DA1 = _RxMessage.Data[1];
        DA2 = _RxMessage.Data[2];
    
        HV_set1=DA1;
        HV_set2=DA2;
    
        setHV(DA1, DA2);
    }

    //Start In-Application programming.... not yet implemented
    else if ((u8)(_RxMessage.Data[0]) == COMMAND_IAP){
        //jumpBL = 1;
    }

    //Fires test pulser 
    else if ((u8)(_RxMessage.Data[0]) == COMMAND_TP){
		if( _RxMessage.Data[1]  == TP_FIRE ){
			TestPulserFlag = 1;
		}
		else if( _RxMessage.Data[1]  == TP_ENBSYNC ){
			GPIO_WriteHigh( TP_PORT, ENB_SYNCTP_PIN );
		}
		else if( _RxMessage.Data[1]  == TP_DISSYNC ){
			GPIO_WriteLow( TP_PORT, ENB_SYNCTP_PIN );
		}
    }

    //Enable or disable HV bits
    else if ((u8)(_RxMessage.Data[0]) == COMMAND_HV){
       
        if ((_RxMessage.Data[1] & 0x80) == 0x80){
			if ((_RxMessage.Data[1] & 0x08) == 0x08){ 
				//ENBHVT_ENABLE; 
				GPIO_WriteHigh(ENB_PORT, ENB_HVT_PIN);
				}
			else { 
				//ENBHVT_DISABLE; 
				GPIO_WriteLow(ENB_PORT, ENB_HVT_PIN);
				}
		}
        if ((_RxMessage.Data[1] & 0x40) == 0x40){
			if ((_RxMessage.Data[1] & 0x04) == 0x04){ 
				//ENBHVB_ENABLE; 
				GPIO_WriteHigh(ENB_PORT, ENB_HVB_PIN);
				}
			else { 
				//ENBHVB_DISABLE; 
				GPIO_WriteLow(ENB_PORT, ENB_HVB_PIN);
				}
		}
        if ((_RxMessage.Data[1] & 0x20) == 0x20){
			if ((_RxMessage.Data[1] & 0x02) == 0x02){ 
				//ENBMVT_ENABLE; 
				GPIO_WriteHigh(ENB_PORT, ENB_MVT_PIN);
				}
			else { 
				//ENBMVT_DISABLE; 
				GPIO_WriteLow(ENB_PORT, ENB_MVT_PIN);
				}
		}
        if ((_RxMessage.Data[1] & 0x10) == 0x10){
			if ((_RxMessage.Data[1] & 0x01) == 0x01){ 
				//ENBMVB_ENABLE; 
				GPIO_WriteHigh(ENB_PORT, ENB_MVB_PIN);
				}
			else { 
				//ENBMVB_DISABLE; 
				GPIO_WriteLow(ENB_PORT, ENB_MVB_PIN);
				}
		}
        if ((_RxMessage.Data[2] & 0x04) == 0x04){
			if ((_RxMessage.Data[2] & 0x01) == 0x01){ 
				//JAMHVB_ENABLE; 
                FlashLEDs(1);
				//GPIO_WriteHigh(ENB_PORT, JAM_HVB_PIN);
				}
			else { 
				//JAMHVB_DISABLE; 
				GPIO_WriteLow(ENB_PORT, JAM_HVB_PIN);
				}
		}
        if ((_RxMessage.Data[2] & 0x08) == 0x08){
			if ((_RxMessage.Data[2] & 0x02) == 0x02){ 
				//JAMHVT_ENABLE; 
				//GPIO_WriteHigh(ENB_PORT, JAM_HVT_PIN);
				}
			else { 
				//JAMHVT_DISABLE; 
				GPIO_WriteLow(ENB_PORT, JAM_HVT_PIN);
				}
		}
		
		// Read status
		if ( ((_RxMessage.Data[1] | 0x0F) == 0x0F)
				&& ((_RxMessage.Data[2] | 0x03) == 0x03) ){
			
				//need to read status of port D 
				//Send CAN message
				TxData[0] = COMMAND_HV;
				hvStatus = (u8)(GPIO_ReadOutputData(ENB_PORT));
				TxData[1] = hvStatus;
				transmitMailbox = CAN_SendData(&TxData[0]);
			}
    }

    //Return board ID
    else if ((u8)(_RxMessage.Data[0]) == COMMAND_ID){
    
		TxData[0] = COMMAND_ID;
		for (i = 1; i < 7; i++){
			TxData[i] = G_BOARDID[i];	// G_BoardID only contains 6 useful bytes
		}
		//Send board ID
		CAN_SendData(&TxData[0]);
        
    }

    // Switch  on red or green LED
    else if ((u8)(_RxMessage.Data[0]) == COMMAND_LED ){
        if ((u8)(_RxMessage.Data[1]) == 0x00 ){  
            // For bases - turn red led on
            //SetLEDs(0x00);
            SetLEDs(LED_RED_PIN);
        }
        else if((u8)(_RxMessage.Data[1]) == 0x01 ){  
            // For bases - turn green led on
            //SetLEDs(0x00);
            SetLEDs(LED_GREEN_PIN);
        }
        else if((u8)(_RxMessage.Data[1]) == 0x02 ){  
            // For bases - turn LED off
            SetLEDs(0x00);
        }
        else if((u8)(_RxMessage.Data[1]) == 0x03 ){  
            // For bases - turn both LEDs on
            //SetLEDs(0x00);
            SetLEDs(LED_RED_PIN | LED_GREEN_PIN);
        }
    }

    //Return version number 
    else if ((u8)(_RxMessage.Data[0]) == COMMAND_VER){
		TxData[0] = COMMAND_VER;
		TxData[1] = (u8)fwareVint;
		TxData[2] = (u8)fwareVflo;
		CAN_SendData(&TxData[0]);
    }

    else if ((u8)(_RxMessage.Data[0]) == COMMAND_STAT){
        if ((u8)(_RxMessage.Data[1]) == 0x01 ){
        
            TxData[0] = FLASH_ReadByte(0x9000);
        
            //DEBUG 
            if (TxData[0] == 0x11)
                FlashLEDs(3);
            CAN_SendData(&TxData[0]);
        }
        if ((u8)(_RxMessage.Data[1]) == 0x02){
        
            FLASH_Unlock(FLASH_MEMTYPE_PROG);
            FLASH_ProgramByte(0x9000, _RxMessage.Data[2]);
            FLASH_Lock(FLASH_MEMTYPE_PROG);
        
        }
    }

}


u8 CAN_SendData(u8 *Data0)
{
    //CanTxMsg TxMessage;	
    u8 TransmitMailbox;
    int txcnt;
	
	/* transmit */

	// set the ID to the board ID -- base should never transmit a message with ID 0x0
    _TxMessage.StdId=(u16)(0x0000);
    _TxMessage.ExtId_28_24=0x00;
    _TxMessage.ExtId_23_16=G_BOARDID[3];
    _TxMessage.ExtId_15_8=G_BOARDID[2];
    _TxMessage.ExtId_7_0=G_BOARDID[1];
    _TxMessage.IDE=CAN_ID_EXT;
    _TxMessage.RTR=CAN_RTR_DATA;
    _TxMessage.DLC=8;
    _TxMessage.Data[0]=Data0[0];
    _TxMessage.Data[1]=Data0[1];
    _TxMessage.Data[2]=Data0[2];
	_TxMessage.Data[3]=Data0[3];
    _TxMessage.Data[4]=Data0[4];
	_TxMessage.Data[5]=Data0[5];
	_TxMessage.Data[6]=Data0[6];
	_TxMessage.Data[7]=Data0[7];

    TransmitMailbox = CAN_Transmit(&_TxMessage);
	

    txcnt = 0;
    while( ( CAN_TransmitStatus(TransmitMailbox) ) != CANTXOK )
    {

		
		if ( (CAN_TransmitStatus(TransmitMailbox) ) == CANTXPENDING )
		{
			
		}
		
		if ( (CAN_TransmitStatus(TransmitMailbox) ) == CANTXFAILED )
		{
			
		}		
	
		txcnt++;
        // Exit after a given number of retries
        if(txcnt > 100000)
        {				
				switch(TransmitMailbox)
				{
				case 0:
					CAN_PSR = 0x00;
					break;
				case 1:
					CAN_PSR = 0x01;
					break;
				case 2:
					CAN_PSR = 0x05;
					break;
				default:
					CAN_PSR = 0x00;
					break;
				}
	
				/* abort transmission */
				CAN_MCSR |= CAN_MCSR_ABRQ;	
				CAN_PSR = 0x00;
				break;
        }	
    }
	

	// pull CAN_STBY high again...
    return TransmitMailbox;
}


