/**
  ******************************************************************************
  * @file stm8s_it.c\RIDE_Project
  * @brief This file contains all the interrupt routines.
  * @author STMicroelectronics
  * @version V0.03
  * @date 29-NOV-2007
  ******************************************************************************
  *
  * THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2007 STMicroelectronics</center></h2>
  * @image html logo.bmp
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "stm8s_lib.h"
#include "stm8s_can.h"
#include "config_commands.h"
#include "firmware_config.h"
#include "CAN_Message.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
/* Public functions ----------------------------------------------------------*/

/* Public Interruption routines ----------------------------------------------------------*/
void CLK_IRQHandler (void) interrupt 2
{
	CAN_TransmitPowerUp();
}

void EXTI_PORTC_IRQHandler (void) interrupt 5
{
	// An interrupt has been generated on PC1 pin which is
	// OR-d with CAN-RX.
	// This interrupt has priority over CAN_RX interrupt.
	// Pull CAN_STBY low, so that MCU can read CAN message.
	CAN_TransmitPowerUp();
	delay(50);
}
void CAN_RX_IRQHandler (void) interrupt 8
{   
	
	// If test pulser is running, this will stop it...
	//TestPulserFlag = 0;
	
	// An interrupt generated by activity on CAN_RX pin.
    // Need to read message or interrupt will continuously 
	// be generated.
}
void CAN_TX_IRQHandler (void) interrupt 9
{
	
}

/**
  * @}
  */

/******************* (C) COPYRIGHT 2008 STMicroelectronics *****END OF FILE****/
