/*Include files*/
#include "firmware_config.h"
#include "stm8s_gpio.h"
#include "read_ID.h"
#include "config_commands.h"
#include "stm8s_type.h"
#include <stdio.h>
#include "noptiming.h"

void OWWriteBit(u8 writebit){


    if (writebit){
        // Write '1' bit
        BOARDID_PORT->ODR &= (u8)(~BOARDID_PIN);
         
        BOARDID_PORT->ODR |= BOARDID_PIN;
        NOP100; 
    }

    else{  
        // Write '0' bit
        BOARDID_PORT->ODR &= (u8)(~BOARDID_PIN);
        NOP60; 
        BOARDID_PORT->ODR |= BOARDID_PIN;
        NOP140;
    }
}

unsigned int OWReadID(u8 *id){
	// called when CAN message received requesting ID
	
    u8 result = 0x00;
    u8 result2;
    unsigned int loop;
    u8 byte = 0x33;
    unsigned int i;
    
    /*Initialize output mode*/
    BOARDID_PORT->ODR |= BOARDID_PIN;
    BOARDID_PORT->DDR |= BOARDID_PIN;
    BOARDID_PORT->CR1 &= (u8)(~(BOARDID_PIN));
    BOARDID_PORT->CR2 |= BOARDID_PIN;
    
    // Write low and hold pin low for > 480mus
    BOARDID_PORT->ODR &= (u8)(~BOARDID_PIN);
    NOP500;
    
	// Let pin go... resistor will now pull pin high and then 
	// after a short delay, DS2401 will send presence pulse 
	// i.e. the DS2401 will pull the pin low.
    /*Initialize input mode*/
    BOARDID_PORT->DDR &= (u8)(~(BOARDID_PIN));
    BOARDID_PORT->CR1 &= (u8)(~(BOARDID_PIN));
    BOARDID_PORT->CR2 &= (u8)(~(BOARDID_PIN));
    
    /*Read pin*/
    //result1 = ((BitStatus)(BOARDID_PORT->IDR & (u8)BOARDID_PIN));
    
    NOP500;
    
    /*Initialize output mode*/
    BOARDID_PORT->ODR &= (u8)(~(BOARDID_PIN));
    BOARDID_PORT->DDR |= BOARDID_PIN;
    BOARDID_PORT->CR1 &= (u8)(~(BOARDID_PIN));
    BOARDID_PORT->CR2 |= BOARDID_PIN;
    
    // Loop to write each bit; Least significant bit first
	// For 0x33 this means writing 11001100.
    for (loop = 0; loop < 8; loop++){
        
		// NB byte = 0x33
        OWWriteBit( byte & 0x01);
    
        //Shift data register to next bit 
        byte >>= 1;
    }
    
    for( i = 0; i < 8; i++) {
   
        /*Read byte*/
        for(loop = 0; loop < 8; loop++){
        
			//shift result to get ready for next bit
			result >>= 1;
            
			/*Initialize output mode*/
			BOARDID_PORT->ODR &= (u8)(~(BOARDID_PIN));
			BOARDID_PORT->DDR |= BOARDID_PIN;
			BOARDID_PORT->CR1 &= (u8)(~(BOARDID_PIN));
			BOARDID_PORT->CR2 |= BOARDID_PIN;

			//Write low
			BOARDID_PORT->ODR &= (u8)(~BOARDID_PIN);

			/*Initialize input mode*/
			BOARDID_PORT->DDR &= (u8)(~(BOARDID_PIN));
			BOARDID_PORT->CR1 &= (u8)(~(BOARDID_PIN));
			BOARDID_PORT->CR2 &= (u8)(~(BOARDID_PIN));
        
			NOP12;
            
			//Read pin
			result2 = ((BitStatus)(BOARDID_PORT->IDR & (u8)BOARDID_PIN));
			
			NOP50;
    
			if(result2) result |= 0x80;
        }
        
      id[i] = result;
    }
    
    return 0;
}